Edit

Share via


Items - Create Operations Agent

Creates an OperationsAgent in the specified workspace.

Note

OperationsAgent item is currently in Preview (learn more).

This API supports long running operations (LRO).

To create an OperationsAgent with a definition, refer to OperationsAgent article.

Permissions

The caller must have a contributor workspace role.

Required Delegated Scopes

Item.ReadWrite.All

Limitations

Microsoft Entra supported identities

This API supports the Microsoft identities listed in this section.

Identity Support
User Yes
Service principal and Managed identities No

Interface

POST https://api.fabric.microsoft.com/v1/workspaces/{workspaceId}/operationsAgents

URI Parameters

Name In Required Type Description
workspaceId
path True

string (uuid)

The workspace ID.

Request Body

Name Required Type Description
displayName True

string

The OperationsAgent display name. The display name must follow naming rules according to item type.

definition

OperationsAgentPublicDefinition

The OperationsAgent public definition.

description

string

The OperationsAgent description. Maximum length is 256 characters.

folderId

string (uuid)

The folder ID. If not specified or null, the OperationsAgent is created with the workspace as its folder.

sensitivityLabelSettings

SensitivityLabelSettings

The sensitivity label settings for the OperationsAgent.

Responses

Name Type Description
201 Created

OperationsAgent

Successfully created

202 Accepted

Request accepted, OperationsAgent provisioning in progress.

Headers

  • Location: string
  • x-ms-operation-id: string
  • Retry-After: integer
429 Too Many Requests

ErrorResponse

The service rate limit was exceeded. The server returns a Retry-After header indicating, in seconds, how long the client must wait before sending additional requests.

Headers

Retry-After: integer

Other Status Codes

ErrorResponse

Common error codes:

  • InvalidItemType - Item type is invalid

  • ItemDisplayNameAlreadyInUse - Item display name is already used.

  • CorruptedPayload - The provided payload is corrupted.

  • WorkspaceItemsLimitExceeded - Workspace item limit exceeded.

Examples

Create a OperationsAgent example
Create a OperationsAgent with public definition example

Create a OperationsAgent example

Sample request

POST https://api.fabric.microsoft.com/v1/workspaces/cfafbeb1-8037-4d0c-896e-a46fb27ff229/operationsAgents

{
  "displayName": "OperationsAgent 1",
  "description": "A OperationsAgent description."
}

Sample response

{
  "displayName": "OperationsAgent 1",
  "description": "A OperationsAgent description.",
  "type": "OperationsAgent",
  "workspaceId": "cfafbeb1-8037-4d0c-896e-a46fb27ff229",
  "id": "5b218778-e7a5-4d73-8187-f10824047715",
  "sensitivityLabel": {
    "id": "b7b4f4d9-3f0d-4b3e-8f3d-4f6d3f4f3f4f"
  }
}
Location: https://api.fabric.microsoft.com/v1/operations/0acd697c-1550-43cd-b998-91bfbfbd47c6
x-ms-operation-id: 0acd697c-1550-43cd-b998-91bfbfbd47c6
Retry-After: 30

Create a OperationsAgent with public definition example

Sample request

POST https://api.fabric.microsoft.com/v1/workspaces/cfafbeb1-8037-4d0c-896e-a46fb27ff229/operationsAgents

{
  "displayName": "OperationsAgent 1",
  "description": "A OperationsAgent description.",
  "definition": {
    "format": "OperationsAgentV1",
    "parts": [
      {
        "path": "OperationsAgentV1.json",
        "payload": "eyJleGVjdXRhYmxlRm..OWRmNDhhY2ZmZTgifQ==",
        "payloadType": "InlineBase64"
      },
      {
        "path": ".platform",
        "payload": "ZG90UGxhdGZvcm1CYXNlNjRTdHJpbmc=",
        "payloadType": "InlineBase64"
      }
    ]
  }
}

Sample response

{
  "displayName": "OperationsAgent 1",
  "description": "A OperationsAgent description.",
  "type": "OperationsAgent",
  "workspaceId": "cfafbeb1-8037-4d0c-896e-a46fb27ff229",
  "id": "5b218778-e7a5-4d73-8187-f10824047715",
  "sensitivityLabel": {
    "id": "b7b4f4d9-3f0d-4b3e-8f3d-4f6d3f4f3f4f"
  }
}
Location: https://api.fabric.microsoft.com/v1/operations/0acd697c-1550-43cd-b998-91bfbfbd47c6
x-ms-operation-id: 0acd697c-1550-43cd-b998-91bfbfbd47c6
Retry-After: 30

Definitions

Name Description
AgentState

The current state of the OperationsAgent. Additional AgentState values may be added over time.

CreateOperationsAgentRequest

Create OperationsAgent request payload.

EntireTenantPrincipal

Represents a tenant principal

ErrorRelatedResource

The error related resource details object.

ErrorResponse

The error response.

ErrorResponseDetails

The error response details.

GroupDetails

Group specific details. Applicable when the principal type is Group.

GroupPrincipal

Represents a security group.

GroupType

The type of the group. Additional group types may be added over time.

ItemTag

Represents a tag applied on an item.

ItemType

The type of the item. Additional item types may be added over time.

OperationsAgent

A OperationsAgent object.

OperationsAgentDefinitionFormat

The format of the item definition. Additional format types may be added over time.

OperationsAgentProperties

The OperationsAgent properties.

OperationsAgentPublicDefinition

OperationsAgent public definition object. Refer to this article for more details on the structure of the OperationsAgent definition.

OperationsAgentPublicDefinitionPart

OperationsAgent definition part object.

PayloadType

The type of the definition part payload. Additional payload types may be added over time.

PrincipalType

The type of the principal. Additional principal types may be added over time.

SensitivityLabel

Represents a sensitivity label applied to an item.

SensitivityLabelApplyStrategy

The strategy for applying the sensitivity label. The default value is ApplyOrFail. Additional types may be added over time.

SensitivityLabelSettings

The sensitivity label settings.

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

ServicePrincipalPrincipal

Represents a Microsoft Entra service principal.

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

ServicePrincipalProfilePrincipal

Represents a service principal profile.

UserDetails

User principal specific details. Applicable when the principal type is User.

UserPrincipal

Represents a Microsoft Entra user principal.

AgentState

The current state of the OperationsAgent. Additional AgentState values may be added over time.

Value Description
Active

The OperationsAgent is active and running.

Inactive

The OperationsAgent is inactive and not running.

CreateOperationsAgentRequest

Create OperationsAgent request payload.

Name Type Description
definition

OperationsAgentPublicDefinition

The OperationsAgent public definition.

description

string

The OperationsAgent description. Maximum length is 256 characters.

displayName

string

The OperationsAgent display name. The display name must follow naming rules according to item type.

folderId

string (uuid)

The folder ID. If not specified or null, the OperationsAgent is created with the workspace as its folder.

sensitivityLabelSettings

SensitivityLabelSettings

The sensitivity label settings for the OperationsAgent.

EntireTenantPrincipal

Represents a tenant principal

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

type string:

EntireTenant

The type of the principal. Additional principal types may be added over time.

ErrorRelatedResource

The error related resource details object.

Name Type Description
resourceId

string

The resource ID that's involved in the error.

resourceType

string

The type of the resource that's involved in the error.

ErrorResponse

The error response.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

moreDetails

ErrorResponseDetails[]

List of additional error details.

relatedResource

ErrorRelatedResource

The error related resource details.

requestId

string (uuid)

ID of the request associated with the error.

ErrorResponseDetails

The error response details.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

relatedResource

ErrorRelatedResource

The error related resource details.

GroupDetails

Group specific details. Applicable when the principal type is Group.

Name Type Description
groupType

GroupType

The type of the group. Additional group types may be added over time.

GroupPrincipal

Represents a security group.

Name Type Description
displayName

string

The principal's display name.

groupDetails

GroupDetails

Group specific details. Applicable when the principal type is Group.

id

string (uuid)

The principal's ID.

type string:

Group

The type of the principal. Additional principal types may be added over time.

GroupType

The type of the group. Additional group types may be added over time.

Value Description
Unknown

Principal group type is unknown.

SecurityGroup

Principal is a security group.

DistributionList

Principal is a distribution list.

ItemTag

Represents a tag applied on an item.

Name Type Description
displayName

string

The name of the tag.

id

string (uuid)

The tag ID.

ItemType

The type of the item. Additional item types may be added over time.

Value Description
Dashboard

PowerBI dashboard.

Report

PowerBI report.

SemanticModel

PowerBI semantic model.

PaginatedReport

PowerBI paginated report.

Datamart

PowerBI datamart.

Lakehouse

A lakehouse.

Eventhouse

An eventhouse.

Environment

An environment.

KQLDatabase

A KQL database.

KQLQueryset

A KQL queryset.

KQLDashboard

A KQL dashboard.

DataPipeline

A data pipeline.

Notebook

A notebook.

SparkJobDefinition

A spark job definition.

MLExperiment

A machine learning experiment.

MLModel

A machine learning model.

Warehouse

A warehouse.

Eventstream

An eventstream.

SQLEndpoint

An SQL endpoint.

MirroredWarehouse

A mirrored warehouse.

MirroredDatabase

A mirrored database.

Reflex

A Reflex.

GraphQLApi

An API for GraphQL item.

MountedDataFactory

A MountedDataFactory.

SQLDatabase

A SQLDatabase.

CopyJob

A Copy job.

VariableLibrary

A VariableLibrary.

Dataflow

A Dataflow.

ApacheAirflowJob

An ApacheAirflowJob.

WarehouseSnapshot

A Warehouse snapshot.

DigitalTwinBuilder

A DigitalTwinBuilder.

DigitalTwinBuilderFlow

A Digital Twin Builder Flow.

MirroredAzureDatabricksCatalog

A mirrored azure databricks catalog.

Map

A Map.

AnomalyDetector

An Anomaly Detector.

UserDataFunction

A User Data Function.

GraphModel

A GraphModel.

GraphQuerySet

A Graph QuerySet.

SnowflakeDatabase

A Snowflake Database to store Iceberg tables created from Snowflake account.

OperationsAgent

A OperationsAgent.

CosmosDBDatabase

A Cosmos DB Database.

Ontology

An Ontology.

EventSchemaSet

An EventSchemaSet.

DataAgent

A DataAgent.

OperationsAgent

A OperationsAgent object.

Name Type Description
defaultIdentity Principal:

The item's default identity.

description

string

The item description.

displayName

string

The item display name.

folderId

string (uuid)

The folder ID.

id

string (uuid)

The item ID.

properties

OperationsAgentProperties

The OperationsAgent properties.

sensitivityLabel

SensitivityLabel

The item sensitivity label.

tags

ItemTag[]

List of applied tags.

type

ItemType

The item type.

workspaceId

string (uuid)

The workspace ID.

OperationsAgentDefinitionFormat

The format of the item definition. Additional format types may be added over time.

Value Description
OperationsAgentV1

The V1 JSON format for the OperationsAgent public definition, specifically designed to support CI/CD scenarios in Fabric. See OperationsAgent - OperationsAgentV1 specification for more details.

OperationsAgentProperties

The OperationsAgent properties.

Name Type Description
state

AgentState

The current state of the OperationsAgent. Additional AgentState values may be added over time.

OperationsAgentPublicDefinition

OperationsAgent public definition object. Refer to this article for more details on the structure of the OperationsAgent definition.

Name Type Description
format

OperationsAgentDefinitionFormat

The format of the item definition. Additional format types may be added over time.

parts

OperationsAgentPublicDefinitionPart[]

A list of definition parts.

OperationsAgentPublicDefinitionPart

OperationsAgent definition part object.

Name Type Description
path

string

The OperationsAgent public definition part path.

payload

string

The OperationsAgent public definition part payload.

payloadType

PayloadType

The payload type.

PayloadType

The type of the definition part payload. Additional payload types may be added over time.

Value Description
InlineBase64

Inline Base 64.

PrincipalType

The type of the principal. Additional principal types may be added over time.

Value Description
User

Principal is a Microsoft Entra user principal.

ServicePrincipal

Principal is a Microsoft Entra service principal.

Group

Principal is a security group.

ServicePrincipalProfile

Principal is a service principal profile.

EntireTenant

Principal represents all tenant users.

SensitivityLabel

Represents a sensitivity label applied to an item.

Name Type Description
id

string (uuid)

The sensitivity label ID.

SensitivityLabelApplyStrategy

The strategy for applying the sensitivity label. The default value is ApplyOrFail. Additional types may be added over time.

Value Description
ApplyOrFail

Apply the sensitivity label or fail the operation if it cannot be applied.

Ignore

Ignore the sensitivity label if it cannot be applied and proceed with the operation without applying the label.

SensitivityLabelSettings

The sensitivity label settings.

Name Type Description
labelId

string (uuid)

The sensitivity label ID.

sensitivityLabelApplyStrategy

SensitivityLabelApplyStrategy

The strategy for applying the sensitivity label.

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

Name Type Description
aadAppId

string (uuid)

The service principal's Microsoft Entra AppId.

ServicePrincipalPrincipal

Represents a Microsoft Entra service principal.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

servicePrincipalDetails

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

type string:

ServicePrincipal

The type of the principal. Additional principal types may be added over time.

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

Name Type Description
parentPrincipal Principal:

The service principal profile's parent principal.

ServicePrincipalProfilePrincipal

Represents a service principal profile.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

servicePrincipalProfileDetails

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

type string:

ServicePrincipalProfile

The type of the principal. Additional principal types may be added over time.

UserDetails

User principal specific details. Applicable when the principal type is User.

Name Type Description
userPrincipalName

string

The user principal name.

UserPrincipal

Represents a Microsoft Entra user principal.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

type string:

User

The type of the principal. Additional principal types may be added over time.

userDetails

UserDetails

User principal specific details. Applicable when the principal type is User.